## Katie-4.12.0-Source.tar.xz

=== CMakeLists.txt ===
# Editors notes:
#
# * To find all FIXME/TODO related to the CMake build system (and those
#   inherited from the QMake build system) execute the following in the
#   top-level directory of the source tree:
#
#     find -name '*.cmake' -exec grep -E 'TODO|FIXME' {} +
#     find -name CMakeLists.txt -exec grep -E 'TODO|FIXME' {} +

cmake_minimum_required(VERSION 3.3 FATAL_ERROR)

if(CMAKE_CROSSCOMPILING AND NOT CMAKE_CROSSCOMPILING_EMULATOR)
    message(FATAL_ERROR "Cross-compiling requires CMAKE_CROSSCOMPILING_EMULATOR to be set to QEMU executable, e.g. qemu-arm-static")
endif()

project(Katie C CXX)

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules")
set(CMAKE_AUTOMOC FALSE)
set(CMAKE_AUTOUIC FALSE)
set(CMAKE_AUTORCC FALSE)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/bin")
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/lib")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/staticlib")
set(CMAKE_C_VISIBILITY_PRESET "hidden")
set(CMAKE_CXX_VISIBILITY_PRESET "hidden")
set(CMAKE_VISIBILITY_INLINES_HIDDEN ON)
set(CMAKE_INCLUDE_DIRECTORIES_BEFORE ON)
set(CMAKE_UNITY_BUILD_BATCH_SIZE 300)

# enable symbols visibility preset for all targets
cmake_policy(SET CMP0063 NEW)

# LLVM linker does not have a default library search path, add some directories known to contain
# system wide libraries. the headers search path is also incomplete
if(CMAKE_SYSTEM_NAME MATCHES "BSD")
    foreach(incdir /usr/X11R6/include /usr/X11R7/include /usr/pkg/include /usr/local/include /usr/include)
        if(EXISTS "${incdir}")
            include_directories(${incdir})
        endif()
    endforeach()
    foreach(linkdir /usr/X11R6/lib /usr/X11R7/lib /usr/pkg/lib /usr/local/lib /usr/lib /lib)
        if(EXISTS "${linkdir}")
            link_directories(${linkdir})
        endif()
    endforeach()
endif()

include(CheckCXXCompilerFlag)
include(GNUInstallDirs)
include(CheckIncludeFileCXX)
include(CheckTypeSize)
include(CMakePushCheckState)
include(CheckStructHasMember)
include(CheckCXXSourceRuns)
include(TestBigEndian)
include(FeatureSummary)
include(KatieBuildMacros)

# disable some compiler warnings
set(KATIE_NO_WARNINGS
    # hot attribute used in function prototypes
    -Wno-attributes
    # deprecated X11 and CUPS API used
    -Wno-deprecated -Wno-deprecated-declarations
)
foreach(nowarning ${KATIE_NO_WARNINGS})
    string(REPLACE "-W" "" normalizednowarning "${nowarning}")
    check_cxx_compiler_flag(${nowarning} CXX_${normalizednowarning})
    if(CXX_${normalizednowarning})
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${nowarning}")
    endif()
endforeach()

# https://www.gnu.org/software/libc/manual/html_node/Feature-Test-Macros.html
# https://github.com/Kitware/CMake/blob/master/Modules/CMakeDetermineSystem.cmake
if(CMAKE_SYSTEM_NAME MATCHES "(Linux|GNU)")
    katie_definition(-D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE)
elseif(CMAKE_SYSTEM_NAME MATCHES "(FreeBSD|DragonFly)")
    katie_definition(-D_THREAD_SAFE)
elseif(NOT CMAKE_SYSTEM_NAME MATCHES "(OpenBSD|NetBSD|Solaris|SunOS)")
    message(FATAL_ERROR "Unknown platform '${CMAKE_SYSTEM_NAME}'")
endif()

# mostly relevant to the build process, also stored in the version file for CMake and in qconfig.h.cmake
set(KATIE_MAJOR "4")
set(KATIE_MINOR "12")
set(KATIE_MICRO "0")
set(KATIE_HEX "0x041200")
set(KATIE_VERSION "${KATIE_MAJOR}.${KATIE_MINOR}.${KATIE_MICRO}")

# only for the build process
if(CMAKE_SYSTEM_PROCESSOR)
    string(TOLOWER "${CMAKE_SYSTEM_PROCESSOR}" KATIE_PROCESSOR)
elseif(CMAKE_HOST_SYSTEM_PROCESSOR)
    string(TOLOWER "${CMAKE_HOST_SYSTEM_PROCESSOR}" KATIE_PROCESSOR)
endif()

# used in katie_optimize_headers()
find_program(KATIE_UNIFDEF NAMES unifdef)
if(NOT KATIE_UNIFDEF)
    message(WARNING "Could not find unifdef, headers will not be optimized")
endif()

# used as shebang for profile, exec and dbg scripts
find_program(KATIE_SHELL NAMES sh dash mksh ksh ash)
if(NOT KATIE_SHELL)
    message(FATAL_ERROR "Could not detect shell, supported are: sh, dash, mksh, ksh and ash")
endif()

# should be either STATIC or SHARED
set(KATIE_TYPE SHARED CACHE STRING "Build type")

# components and tools that will be build, changed depending on the requirements availability
set(KATIE_COMPONENTS "Core Gui Declarative Network Svg Xml Script ScriptTools Test UiTools")
set(KATIE_TOOLS "moc uic qscript qtconfig")

set(KATIE_HEADERS_PATH "${CMAKE_INSTALL_FULL_INCLUDEDIR}/katie" CACHE PATH "Headers installation path")
set(KATIE_LIBRARIES_PATH "${CMAKE_INSTALL_FULL_LIBDIR}" CACHE PATH "Libraries installation path")
set(KATIE_BINARIES_PATH "${CMAKE_INSTALL_FULL_BINDIR}" CACHE PATH "Binaries installation path")
set(KATIE_PLUGINS_PATH "${KATIE_LIBRARIES_PATH}/katie/plugins" CACHE PATH "Plugins installation path")
set(KATIE_IMPORTS_PATH "${KATIE_LIBRARIES_PATH}/katie/imports" CACHE PATH "Declarative imports installation path")
set(KATIE_TRANSLATIONS_PATH "${CMAKE_INSTALL_FULL_DATADIR}/translations" CACHE PATH "Translations installation path")
set(KATIE_CMAKE_PATH "${KATIE_LIBRARIES_PATH}/cmake/Katie" CACHE PATH "CMake aware modules installation path")
set(KATIE_LDCONF_PATH "${CMAKE_INSTALL_FULL_SYSCONFDIR}/ld.so.conf.d" CACHE PATH "Run-time linker/loader configs installation path")
set(KATIE_PROFILE_PATH "${CMAKE_INSTALL_FULL_SYSCONFDIR}/profile.d" CACHE PATH "Shell profile scripts installation path")
set(KATIE_MAN_PATH "${CMAKE_INSTALL_FULL_MANDIR}" CACHE PATH "Manual pages installation path")
set(KATIE_APPLICATIONS_PATH "${CMAKE_INSTALL_FULL_DATADIR}/applications" CACHE PATH "Desktop applications register installation path")
set(KATIE_PIXMAPS_PATH "${CMAKE_INSTALL_FULL_DATADIR}/pixmaps" CACHE PATH "Desktop applications icon installation path")
set(KATIE_PKGCONFIG_PATH "${KATIE_LIBRARIES_PATH}/pkgconfig" CACHE PATH "pkg-config installation path")
set(KATIE_TOOLS_SUFFIX "" CACHE STRING "Tools (moc, uic, etc.) suffix")

# bundled packages
option(WITH_DEFLATE "Build with external libdeflate" ON)
add_feature_info(deflate WITH_DEFLATE "build with external libdeflate")

option(WITH_XXHASH "Build with external xxHash" OFF)
add_feature_info(xxhash WITH_XXHASH "build with external xxHash")

# optional packages
option(WITH_CUPS "Build CUPS support" ON)
add_feature_info(cups WITH_CUPS "build CUPS support")

option(WITH_DBUS "Build D-Bus support" ON)
add_feature_info(dbus WITH_DBUS "build D-Bus support")

option(WITH_FONTCONFIG "Build Fontconfig support" ON)
add_feature_info(fontconfig WITH_FONTCONFIG "build Fontconfig support")

option(WITH_GETTEXTPO "Build Gettext support" ON)
add_feature_info(gettextpo WITH_GETTEXTPO "build Gettext support")

option(WITH_EXECINFO "Build ExecInfo support" OFF)
add_feature_info(execinfo WITH_EXECINFO "build ExecInfo support")

# optional features
option(KATIE_TESTS "Build automatic tests" OFF)
add_feature_info(tests KATIE_TESTS "build automatic tests")

option(KATIE_BENCHMARKS "Build automatic benchmarks" OFF)
add_feature_info(benchmarks KATIE_BENCHMARKS "build automatic benchmarks")

option(KATIE_UTILS "Build maintainance utilities" OFF)
add_feature_info(utils KATIE_UTILS "build maintainance utilities")

# v4.6+ required for unorm2_getDecomposition()
find_package(ICU 4.6)
set_package_properties(ICU PROPERTIES
    PURPOSE "Required for locales support"
    DESCRIPTION "Mature, widely used libraries providing Unicode and Globalization support"
    URL "http://site.icu-project.org/"
    TYPE REQUIRED
)

# v2.8+ required for JSON_PARSER_MAX_DEPTH
find_package(Jansson 2.8)
set_package_properties(Jansson PROPERTIES
    PURPOSE "Required for JSON support"
    DESCRIPTION "C library for encoding, decoding and manipulating JSON data"
    URL "https://github.com/akheron/jansson"
    TYPE REQUIRED
)

find_package(X11)
set_package_properties(X11 PROPERTIES
    PURPOSE "Required for X11/X.Org integration support"
    DESCRIPTION "Open source implementation of the X Window System"
    URL "https://www.x.org"
    TYPE REQUIRED
)

find_package(Freetype)
set_package_properties(Freetype PROPERTIES
    PURPOSE "Required for fonts configuration support"
    DESCRIPTION "Freely available software library to render fonts"
    URL "https://www.freetype.org"
    TYPE REQUIRED
)

set(CMAKE_THREAD_PREFER_PTHREAD TRUE)
find_package(Threads)
set_package_properties(Threads PROPERTIES
    PURPOSE "Required for threads support"
    DESCRIPTION "Platform dependent threads implementation"
    URL ""
    TYPE REQUIRED
)

find_package(PNG)
set_package_properties(PNG PROPERTIES
    PURPOSE "PNG format handler"
    DESCRIPTION "A collection of routines used to create PNG format graphics files"
    URL "http://www.libpng.org/pub/png/libpng.html"
    TYPE REQUIRED
)

find_package(Deflate)
set_package_properties(Deflate PROPERTIES
    PURPOSE "Required for compression and decompression support"
    DESCRIPTION "Heavily optimized library for DEFLATE/zlib/gzip compression and decompression"
    URL "https://github.com/ebiggers/libdeflate"
    TYPE RECOMMENDED
)

find_package(xxHash)
set_package_properties(xxHash PROPERTIES
    PURPOSE "Required for the custom hash algorithm"
    DESCRIPTION "Extremely fast non-cryptographic hash algorithm"
    URL "https://cyan4973.github.io/xxHash/"
    TYPE RECOMMENDED
)

find_package(Cups)
set_package_properties(Cups PROPERTIES
    PURPOSE "Required for printing support"
    DESCRIPTION "CUPS is the standards-based, open source printing system"
    URL "https://www.cups.org"
    TYPE RECOMMENDED
)

# v2.4.2+ required for Freetype integration
find_package(Fontconfig 2.4.2)
set_package_properties(Fontconfig PROPERTIES
    PURPOSE "Required for fonts configuration support"
    DESCRIPTION "Library for configuring and customizing font access"
    URL "https://www.freedesktop.org/wiki/Software/fontconfig/"
    TYPE RECOMMENDED
)

# v1.5.12+ required for DBusBasicValue type
find_package(DBus 1.5.12)
set_package_properties(DBus PROPERTIES
    PURPOSE "Required for D-Bus support"
    DESCRIPTION "Message bus system, a simple way for applications to talk to one another"
    URL "https://www.freedesktop.org/wiki/Software/dbus"
    TYPE RECOMMENDED
)

find_package(GettextPO)
set_package_properties(GettextPO PROPERTIES
    PURPOSE "Required for translations support"
    DESCRIPTION "GNU gettext PO files processsor"
    URL "https://www.gnu.org/software/gettext/gettext.html"
    TYPE RECOMMENDED
)

find_package(ExecInfo)
set_package_properties(ExecInfo PROPERTIES
    PURPOSE "Required for stack traces on assert and crash"
    DESCRIPTION "Standard C library specific execinfo implementation"
    URL ""
    TYPE RECOMMENDED
)

find_package(XdgUtils)
set_package_properties(XdgUtils PROPERTIES
    PURPOSE "Required for desktop services"
    DESCRIPTION "Utilities for integrating applications with the desktop environment"
    URL "https://www.freedesktop.org/wiki/Software/xdg-utils/"
    TYPE RUNTIME
)

# stored in qconfig.h.cmake
check_type_size(size_t QT_POINTER_SIZE)

test_big_endian(KATIE_BIG_ENDIAN)
if(KATIE_BIG_ENDIAN)
    set(KATIE_BYTE_ORDER "Q_BIG_ENDIAN")
else()
    set(KATIE_BYTE_ORDER "Q_LITTLE_ENDIAN")
endif()

if(CMAKE_SYSTEM_NAME MATCHES "Linux")
    set(KATIE_OS "LINUX")
elseif(CMAKE_SYSTEM_NAME MATCHES "GNU")
    set(KATIE_OS "HURD")
elseif(CMAKE_SYSTEM_NAME MATCHES "FreeBSD")
    set(KATIE_OS "FREEBSD")
elseif(CMAKE_SYSTEM_NAME MATCHES "DragonFly")
    set(KATIE_OS "DRAGONFLY")
elseif(CMAKE_SYSTEM_NAME MATCHES "OpenBSD")
    set(KATIE_OS "OPENBSD")
elseif(CMAKE_SYSTEM_NAME MATCHES "NetBSD")
    set(KATIE_OS "NETBSD")
elseif(CMAKE_SYSTEM_NAME MATCHES "(Solaris|SunOS)")
    set(KATIE_OS "SOLARIS")
else()
    message(FATAL_ERROR "Unknown platform '${CMAKE_SYSTEM_NAME}'")
endif()

try_run(
    KATIE_ARCH_RUN_RESULT KATIE_ARCH_COMPILE_RESULT
    "${CMAKE_BINARY_DIR}" "${CMAKE_SOURCE_DIR}/cmake/arch.cpp"
    RUN_OUTPUT_VARIABLE KATIE_ARCH
)
if(NOT KATIE_ARCH_RUN_RESULT EQUAL 0 OR NOT KATIE_ARCH_COMPILE_RESULT)
    message(FATAL_ERROR "Unknown CPU '${KATIE_PROCESSOR}'")
endif()

=== tests/CMakeLists.txt ===
# just to make catching binaries other than tests easier in case maintainer forgot to specify
# output directory or something strange happens, no files should be placed there
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/tests")

include_directories(
    ${CMAKE_BINARY_DIR}/include
    ${CMAKE_BINARY_DIR}/privateinclude
    ${CMAKE_BINARY_DIR}/include/QtCore
    ${CMAKE_BINARY_DIR}/include/QtGui
    ${CMAKE_BINARY_DIR}/include/QtDBus
    ${CMAKE_BINARY_DIR}/include/QtDeclarative
    ${CMAKE_BINARY_DIR}/include/QtNetwork
    ${CMAKE_BINARY_DIR}/include/QtSvg
    ${CMAKE_BINARY_DIR}/include/QtXml
    ${CMAKE_BINARY_DIR}/include/QtScript
    ${CMAKE_BINARY_DIR}/include/QtScriptTools
    ${CMAKE_BINARY_DIR}/include/QtTest
    ${CMAKE_BINARY_DIR}/include/QtUiTools
)

# FIXME: most tests are not namespaces aware
add_definitions(-DQT_NAMESPACE_COMPAT)

if(KATIE_TESTS)
    add_subdirectory(auto)
endif()
if(KATIE_BENCHMARKS)
    add_subdirectory(benchmarks)
endif()

=== translations/CMakeLists.txt ===
file(GLOB TRANSLATIONS "*.po")

foreach(tmpres ${TRANSLATIONS})
    get_filename_component(resource "${tmpres}" ABSOLUTE)
    get_filename_component(rscname "${resource}" NAME_WE)
    make_directory("${CMAKE_CURRENT_BINARY_DIR}")
    set(rscout "${CMAKE_CURRENT_BINARY_DIR}/${rscname}.tr")
    if("${rscname}" MATCHES "qt_tools")
        set(rscbase "qt_tools")
        string(REPLACE "qt_tools_" "" rsclocale "${rscname}")
    else()
        set(rscbase "qt")
        string(REPLACE "qt_" "" rsclocale "${rscname}")
    endif()
    add_custom_target(
        translations_${rscname} ALL
        COMMAND "${CMAKE_BINARY_DIR}/exec.sh" "${CMAKE_BINARY_DIR}/bin/trc${KATIE_TOOLS_SUFFIX}" "${resource}" -o "${rscout}"
        DEPENDS "trc"
        COMMENT "Generating ${rscname}.tr"
    )
    set_source_files_properties("${rscout}" PROPERTIES GENERATED TRUE)
    install(
        FILES "${rscout}"
        DESTINATION "${KATIE_TRANSLATIONS_PATH}/${rsclocale}"
        RENAME "${rscbase}.tr"
        COMPONENT Runtime
    )
endforeach()

=== util/CMakeLists.txt ===
add_subdirectory(fixnonlatin1)
add_subdirectory(lexgen)
add_subdirectory(normalize)
add_subdirectory(plugintest)
add_subdirectory(qlalr)
add_subdirectory(imgconv)
add_subdirectory(filehash)

=== package/freebsd/Makefile ===
# https://docs.freebsd.org/en/books/porters-handbook/

PORTNAME = katie
DISTVERSION = 4.12.0.d20201231
CATEGORIES = devel x11 net
MAINTAINER = xakepa10@gmail.com
COMMENT = C++ toolkit derived from the Qt 4.8 framework
LICENSE = BSD3CLAUSE LGPL21+
LICENSE_COMB = multi

MASTER_SITES = https://osdn.net/projects/kde/news/
DISTFILES = rss
DIST_SUBDIR = ${PORTNAME}
WRKSRC = ${WRKDIR}/katie.git

USES = compiler:c++11-lang pkgconfig cmake xorg desktop-file-utils
USE_XORG = x11 xinerama xrandr xrender xfixes xcursor xext sm ice
USE_LDCONFIG = yes
USE_GETTEXT_TOOLS = build run
RUN_DEPENDS = xdg-open:devel/xdg-utils \
	${LOCALBASE}/share/fonts/freefont-ttf/FreeSans.ttf:x11-fonts/freefont-ttf
LIB_DEPENDS = libdeflate.so:archivers/libdeflate libicuuc.so:devel/icu \
	libicui18n.so:devel/icu libjansson.so:devel/jansson \
	libpng.so:graphics/png libfreetype.so:print/freetype2 \
	libfontconfig.so:x11-fonts/fontconfig libdbus-1.so:devel/dbus \
	libcups.so:print/cups
CMAKE_ARGS = -DKATIE_TOOLS_SUFFIX="-katie" -Wno-dev

OPTIONS_DEFINE = NLS
OPTIONS_SUB = yes
NLS_DESC = Build translator and translations
NLS_USES = gettext-tools
NLS_CMAKE_ON = -DWITH_GETTEXTPO=TRUE
NLS_CMAKE_OFF = -DWITH_GETTEXTPO=FALSE

do-extract:
	@rm -vrf ${WRKSRC}
	@git clone --depth=1 git://git.osdn.net/gitroot/kde/Katie.git ${WRKSRC}

.include <bsd.port.mk>

=== src/core/CMakeLists.txt ===
# add_definitions()
set(EXTRA_CORE_LIBS
    ${ICU_LIBRARIES}
    ${JANSSON_LIBRARIES}
    ${CMAKE_THREAD_LIBS_INIT}
    # libm should be present by default becaue this is C++
    m
)

set(CORE_PUBLIC_HEADERS
    QVarLengthArray
    QList
    QProcess
    QBuffer
    QStringMatcher
    QScopedPointer
    QSet
    QHash
    QLibrary
    QObjectCleanupHandler
    QTranslator
    QWaitCondition
    QMimeData
    QBitArray
    QChar
    QMap
    QTextStream
    QDebug
    QFileInfo
    QDateTime
    QThreadPool
    QSettings
    QStandardPaths
    QPlugin
    QPluginLoader
    QLine
    QIODevice
    QPair
    QPoint
    QByteArray
    QSharedData
    QPointer
    QSignalMapper
    QEventLoop
    QDataStream
    QScopedValueRollback
    QAbstractItemModel
    QTextBoundaryFinder
    QTimer
    QElapsedTimer
    QUrl
    QVector
    QLibraryInfo
    QSemaphore
    QStack
    QTemporaryFile
    QQueue
    QMutex
    QMargins
    QByteArrayMatcher
    QDirIterator
    QFileSystemWatcher
    QSharedPointer
    QSize
    QRect
    QCoreApplication
    QRegExp
    QMetaObject
    QDir
    QObject
    QString
    QLocale
    QMetaType
    QVariant
    QFile
    QCache
    QAbstractEventDispatcher
    QRunnable
    QTimeLine
    QTextCodec
    QStringList
    QEasingCurve
    QBasicTimer
    QThread
    QSocketNotifier
    QJsonDocument
)

include_directories(
    ${CMAKE_BINARY_DIR}/include
    ${CMAKE_BINARY_DIR}/privateinclude
    ${CMAKE_BINARY_DIR}/include/QtCore
    ${ICU_INCLUDES}
    ${JANSSON_INCLUDES}
)

set(CORE_HEADERS
    ${CMAKE_CURRENT_SOURCE_DIR}/codecs/qtextcodec.h
    ${CMAKE_CURRENT_SOURCE_DIR}/codecs/qtextcodec_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/global/qendian.h
    ${CMAKE_CURRENT_SOURCE_DIR}/global/qglobal.h
    ${CMAKE_CURRENT_SOURCE_DIR}/global/qlibraryinfo.h
    ${CMAKE_CURRENT_SOURCE_DIR}/global/qnamespace.h
    ${CMAKE_CURRENT_SOURCE_DIR}/global/qnumeric.h
    ${CMAKE_CURRENT_SOURCE_DIR}/global/qplatformdefs.h
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qbuffer.h
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qdatastream.h
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qdataurl_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qdebug.h
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qdir.h
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qdir_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qdiriterator.h
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qfile.h
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qfileinfo.h
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qfileinfo_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qiodevice.h
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qiodevice_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qprocess.h
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qprocess_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qtextstream.h
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qtemporaryfile.h
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qurl.h
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qtldurl_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qsettings.h
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qsettings_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qstandardpaths.h
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qfilesystemwatcher.h
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qfilesystemwatcher_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qfilesystemwatcher_unix_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qfilesystementry_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qfilesystemengine_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qfilesystemmetadata_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qfilesystemiterator_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qabstracteventdispatcher.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qabstractitemmodel.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qabstractitemmodel_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qbasictimer.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qeventloop.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qpointer.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qcoreapplication.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qcoreevent.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qmetaobject.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qmetatype.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qmimedata.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qobject.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qobjectdefs.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qsignalmapper.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qsocketnotifier.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qtimer.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qtranslator.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qvariant.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qabstracteventdispatcher_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qcoreapplication_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qobjectcleanuphandler.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qvariant_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qmetaobject_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qobject_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qmath.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qcore_unix_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qeventdispatcher_unix_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/plugin/qpluginloader.h
    ${CMAKE_CURRENT_SOURCE_DIR}/plugin/qlibrary.h
    ${CMAKE_CURRENT_SOURCE_DIR}/plugin/qlibrary_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/plugin/qplugin.h
    ${CMAKE_CURRENT_SOURCE_DIR}/plugin/qfactoryloader_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/thread/qmutex.h
    ${CMAKE_CURRENT_SOURCE_DIR}/thread/qsemaphore.h
    ${CMAKE_CURRENT_SOURCE_DIR}/thread/qthread.h
    ${CMAKE_CURRENT_SOURCE_DIR}/thread/qwaitcondition.h
    ${CMAKE_CURRENT_SOURCE_DIR}/thread/qatomic.h
    ${CMAKE_CURRENT_SOURCE_DIR}/thread/qmutexpool_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/thread/qorderedmutexlocker_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/thread/qthread_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/thread/qrunnable.h
    ${CMAKE_CURRENT_SOURCE_DIR}/thread/qthreadpool.h
    ${CMAKE_CURRENT_SOURCE_DIR}/thread/qthreadpool_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qalgorithms.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qbitarray.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qbytearray.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qbytearraymatcher.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qcache.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qchar.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qcontainerfwd.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qdatetime.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qdatetime_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qeasingcurve.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qhash.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qjsondocument.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qline.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qlist.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qlocale.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qlocale_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qlocale_tools_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qlocale_data_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qmap.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qmargins.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qpoint.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qqueue.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qrect.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qregexp.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qringbuffer_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qscopedpointer.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qscopedpointer_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qscopedvaluerollback.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qshareddata.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qsharedpointer.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qset.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qsize.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qstack.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qstring.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qstringlist.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qstringmatcher.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qtextboundaryfinder.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qtimeline.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qelapsedtimer.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qvarlengtharray.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qvector.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qiterator.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qpair.h
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qstdcontainers_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qcorecommon_p.h
)

set(CORE_SOURCES
    ${CMAKE_CURRENT_SOURCE_DIR}/codecs/qtextcodec.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/global/qglobal.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/global/qlibraryinfo.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/global/qt_error_string.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qbuffer.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qdatastream.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qdataurl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qtldurl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qdebug.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qdir.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qdiriterator.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qfile.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qfileinfo.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qiodevice.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qprocess.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qtextstream.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qtemporaryfile.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qurl.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qsettings.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qstandardpaths.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qfilesystemwatcher.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qfilesystemwatcher_unix.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qfilesystementry.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qfilesystemengine_unix.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qprocess_unix.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qfilesystemiterator_unix.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/io/qstandardpaths_unix.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qabstracteventdispatcher.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qabstractitemmodel.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qbasictimer.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qeventloop.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qcoreapplication.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qcoreevent.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qmetaobject.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qmetatype.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qmimedata.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qobject.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qobjectcleanuphandler.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qsignalmapper.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qsocketnotifier.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qtimer.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qtranslator.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qvariant.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qpointer.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qcore_unix.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qeventdispatcher_unix.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/plugin/qpluginloader.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/plugin/qfactoryloader.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/plugin/qlibrary.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/plugin/qlibrary_unix.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thread/qatomic.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thread/qmutex.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thread/qrunnable.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thread/qsemaphore.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thread/qthread.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thread/qthreadpool.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thread/qthread_unix.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/thread/qwaitcondition_unix.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qbitarray.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qbytearray.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qbytearraymatcher.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qchar.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qdatetime.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qeasingcurve.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qelapsedtimer.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qhash.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qjsondocument.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qline.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qlist.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qlocale.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qlocale_tools.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qpoint.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qmap.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/tools/qmargins.cpp

=== src/dbus/CMakeLists.txt ===
add_definitions(
    -DDBUS_API_SUBJECT_TO_CHANGE
)
set(EXTRA_DBUS_LIBS
    KtCore KtXml
    ${DBUS_LIBRARIES}
)

set(DBUS_PUBLIC_HEADERS
    QDBusAbstractAdaptor
    QDBusAbstractInterface
    QDBusArgument
    QDBusConnection
    QDBusConnectionInterface
    QDBusContext
    QDBusError
    QDBusInterface
    QDBusMessage
    QDBusMetaType
    QDBusPendingCall
    QDBusPendingReply
    QDBusReply
    QDBusServer
    QDBusServiceWatcher
    QDBusUnixFileDescriptor
)

include_directories(
    ${CMAKE_BINARY_DIR}/include
    ${CMAKE_BINARY_DIR}/privateinclude
    ${CMAKE_BINARY_DIR}/include/QtCore
    ${CMAKE_BINARY_DIR}/include/QtXml
    ${CMAKE_BINARY_DIR}/include/QtDBus
    ${DBUS_INCLUDES}
)

set(DBUS_HEADERS
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusargument.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusconnectioninterface.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbuserror.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusextratypes.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusmessage.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusserver.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusconnection.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusabstractinterface.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusinterface.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusabstractadaptor.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusreply.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusmetatype.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbuspendingcall.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbuspendingreply.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbuscontext.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusconnection_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusmessage_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusinterface_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusxmlparser_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusabstractadaptor_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusargument_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusutil_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusabstractinterface_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbuscontext_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusthreaddebug_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusintegrator_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbuspendingcall_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusmetaobject_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusintrospection_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusservicewatcher.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusunixfiledescriptor.h
)

set(DBUS_SOURCES
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusconnection.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusconnectioninterface.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbuserror.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusintegrator.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusmessage.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusserver.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusabstractinterface.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusinterface.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusxmlparser.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusutil.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusintrospection.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusabstractadaptor.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusinternalfilters.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusmetaobject.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusxmlgenerator.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusmisc.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusargument.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusreply.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusmetatype.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusextratypes.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbuscontext.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbuspendingcall.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbuspendingreply.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusservicewatcher.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/qdbusunixfiledescriptor.cpp
)

katie_generate_misc("${DBUS_HEADERS}" QtDBus)
katie_generate_public("${DBUS_PUBLIC_HEADERS}" QtDBus)
katie_generate_package(KtDBus "KtCore KtXml")
katie_setup_target(KtDBus ${DBUS_SOURCES} ${DBUS_HEADERS})

add_library(KtDBus ${KATIE_TYPE} ${KtDBus_SOURCES})
target_link_libraries(KtDBus PRIVATE ${EXTRA_DBUS_LIBS})
set_target_properties(KtDBus PROPERTIES
    VERSION ${KATIE_MAJOR}.${KATIE_MINOR}
    SOVERSION ${KATIE_VERSION}
    EXPORT_NAME DBus
)

install(
    TARGETS KtDBus
    EXPORT KatieTargets
    DESTINATION ${KATIE_LIBRARIES_PATH}
    COMPONENT Runtime
)

install(
    DIRECTORY ${CMAKE_BINARY_DIR}/include/QtDBus
    DESTINATION ${KATIE_HEADERS_PATH}
    COMPONENT Devel
)

katie_optimize_headers(${KATIE_HEADERS_PATH}/QtDBus)

=== src/declarative/CMakeLists.txt ===
add_definitions(
    -DQT_NO_URL_CAST_FROM_STRING
)
set(EXTRA_DECLARATIVE_LIBS
    KtCore KtGui KtNetwork KtScript
)

set(DECLARATIVE_PUBLIC_HEADERS
    QDeclarativeComponent
    QDeclarativeContext
    QDeclarativeEngine
    QDeclarativeError
    QDeclarativeExpression
    QDeclarativeExtensionInterface
    QDeclarativeExtensionPlugin
    QDeclarativeImageProvider
    QDeclarativeInfo
    QDeclarativeItem
    QDeclarativeParserStatus
    QDeclarativeProperty
    QDeclarativePropertyMap
    QDeclarativePropertyValueInterceptor
    QDeclarativePropertyValueSource
    QDeclarativeScriptString
    QDeclarativeView
)

include_directories(
    ${CMAKE_BINARY_DIR}/include
    ${CMAKE_BINARY_DIR}/privateinclude
    ${CMAKE_BINARY_DIR}/include/QtCore
    ${CMAKE_BINARY_DIR}/include/QtGui
    ${CMAKE_BINARY_DIR}/include/QtNetwork
    ${CMAKE_BINARY_DIR}/include/QtScript
    ${CMAKE_BINARY_DIR}/include/QtDeclarative
    ${CMAKE_SOURCE_DIR}/src/3rdparty/harfbuzz/src
)
set(DECLARATIVE_HEADERS
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeitemsmodule_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeanchors_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeanchors_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeevents_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeflickable_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeflickable_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeflipable_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativegridview_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeimage_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeimagebase_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeborderimage_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativepainteditem_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativepainteditem_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeimage_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeborderimage_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeimagebase_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeanimatedimage_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeanimatedimage_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeitem.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeitem_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativefocuspanel_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativefocusscope_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativepositioners_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativepositioners_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeloader_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeloader_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativemousearea_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativemousearea_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativepath_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativepath_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativepathview_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativepathview_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativerectangle_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativerectangle_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativerepeater_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativerepeater_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativescalegrid_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativetranslate_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativetextinput_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativetextinput_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativetextedit_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativetextedit_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativetext_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativetext_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativevisualitemmodel_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativelistview_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativelayoutitem_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeitemchangelistener_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativegraphicswidget_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeimplicitsizeitem_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeimplicitsizeitem_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeparser_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeglobal_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeinstruction_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativevmemetaobject_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarative.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativebinding_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativebinding_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeproperty.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativecomponent.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativecomponent_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativecustomparser_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativecustomparser_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativepropertyvaluesource.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativepropertyvalueinterceptor.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeboundsignal_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeparserstatus.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeproxymetaobject_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativevme_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativecompiler_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeengine_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeexpression_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeprivate.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativerefcount_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativemetatype_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeengine.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativecontext.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeexpression.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativestringconverters_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeinfo.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeproperty_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativecontext_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeinclude_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativetypeloader_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativelist.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativelist_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativedata_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeerror.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativescriptparser_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativerewrite_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qpodvector_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativevaluetype_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativecompiledbindings_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qmetaobjectbuilder_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativecleanup_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativepropertycache_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativenotifier_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeintegercache_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativetypenotavailable_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativetypenamecache_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativescriptstring.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeobjectscriptclass_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativecontextscriptclass_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeglobalscriptclass_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativevaluetypescriptclass_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativetypenamescriptclass_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativelistscriptclass_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeworkerscript_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeguard_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeimageprovider.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativedirparser_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeextensioninterface.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeimport_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/qdeclarativeextensionplugin.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/parser/qdeclarativejsast_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/parser/qdeclarativejsastfwd_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/parser/qdeclarativejsastvisitor_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/parser/qdeclarativejsengine_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/parser/qdeclarativejsgrammar_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/parser/qdeclarativejslexer_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/parser/qdeclarativejsmemorypool_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/parser/qdeclarativejsnodepool_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/parser/qdeclarativejsparser_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qml/rewriter/textwriter_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativeapplication_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativeutilmodule_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativeview.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativeconnections_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativepackage_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativeanimation_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativeanimation_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativesystempalette_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativespringanimation_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativesmoothedanimation_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativesmoothedanimation_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativestate_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativestateoperations_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativepropertychanges_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativestate_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativetransitionmanager_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativestategroup_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativetransition_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativelistmodel_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativelistmodel_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativelistaccessor_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativeopenmetaobject_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativenullablevalue_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativetimeline_p_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativetimer_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativebind_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativepropertymap.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativepixmapcache_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativebehavior_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativestyledtext_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qdeclarativelistmodelworkeragent_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/util/qlistmodelinterface_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qdeclarativecommon_p.h
)

set(DECLARATIVE_SOURCES
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeitemsmodule.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeanchors.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeevents.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeflickable.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeflipable.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativegridview.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsitems/qdeclarativeimage.cpp

=== src/gui/CMakeLists.txt ===
add_definitions(${PNG_DEFINITIONS})
set(EXTRA_GUI_LIBS
    KtCore KtXml
    ${FREETYPE_LIBRARIES}
    ${X11_X11_LIB}
    ${PNG_LIBRARIES}
)

set(GUI_PUBLIC_HEADERS
    QPropertyAnimation
    QPauseAnimation
    QAnimationGroup
    QVariantAnimation
    QSequentialAnimationGroup
    QParallelAnimationGroup
    QAbstractAnimation
    QAbstractButton
    QAbstractItemDelegate
    QAbstractItemView
    QAbstractPageSetupDialog
    QAbstractPrintDialog
    QAbstractProxyModel
    QAbstractScrollArea
    QAbstractSlider
    QAbstractSpinBox
    QAbstractTextDocumentLayout
    QAction
    QActionGroup
    QApplication
    QBitmap
    QBoxLayout
    QBrush
    QButtonGroup
    QCalendarWidget
    QCheckBox
    QCleanlooksStyle
    QClipboard
    QColor
    QColorDialog
    QColumnView
    QComboBox
    QCommandLinkButton
    QCommonStyle
    QCompleter
    QCursor
    QDataWidgetMapper
    QDateTimeEdit
    QDesktopWidget
    QDial
    QDialog
    QDialogButtonBox
    QDirModel
    QDockWidget
    QDrag
    QFileDialog
    QFileIconProvider
    QFileSystemModel
    QFocusFrame
    QFont
    QFontComboBox
    QFontDatabase
    QFontDialog
    QFontInfo
    QFontMetrics
    QFormLayout
    QFrame
    QGenericMatrix
    QGraphicsAnchorLayout
    QGraphicsGridLayout
    QGraphicsItem
    QGraphicsItemAnimation
    QGraphicsLayout
    QGraphicsLayoutItem
    QGraphicsLinearLayout
    QGraphicsProxyWidget
    QGraphicsScene
    QGraphicsSceneEvent
    QGraphicsView
    QGraphicsWidget
    QGridLayout
    QGroupBox
    QHeaderView
    QIcon
    QIconEngine
    QIconEnginePlugin
    QIdentityProxyModel
    QImage
    QImageIOHandler
    QImageReader
    QImageWriter
    QInputDialog
    QItemDelegate
    QItemEditorFactory
    QItemSelectionModel
    QKeySequence
    QLabel
    QLayout
    QLayoutItem
    QLCDNumber
    QLineEdit
    QListView
    QListWidget
    QMainWindow
    QMatrix
    QMatrix4x4
    QMdiArea
    QMdiSubWindow
    QMenu
    QMenuBar
    QMovie
    QPageSetupDialog
    QPaintDevice
    QPaintEngine
    QPainter
    QPainterPath
    QPalette
    QPen
    QPixmap
    QPixmapCache
    QPlainTextEdit
    QPolygon
    QPrintDialog
    QPrintEngine
    QPrinter
    QPrinterInfo
    QPrintPreviewDialog
    QPrintPreviewWidget
    QProgressBar
    QProgressDialog
    QProxyModel
    QProxyStyle
    QPushButton
    QRadioButton
    QRegion
    QRgb
    QRubberBand
    QScrollArea
    QScrollBar
    QSessionManager
    QShortcut
    QSizeGrip
    QSizePolicy
    QSlider
    QSortFilterProxyModel
    QSpinBox
    QSplashScreen
    QSplitter
    QStackedLayout
    QStackedWidget
    QStandardItemModel
    QStatusBar
    QStringListModel
    QStyle
    QStyledItemDelegate
    QStyleFactory
    QStyleOption
    QStylePainter
    QStylePlugin
    QSyntaxHighlighter
    QSystemTrayIcon
    QTabBar
    QTableView
    QTableWidget
    QTabWidget
    QTextBrowser
    QTextCursor
    QTextDocument
    QTextDocumentFragment
    QTextDocumentWriter
    QTextEdit
    QTextFormat
    QTextLayout
    QTextList
    QTextObject
    QTextOption
    QTextTable
    QToolBar
    QToolBox
    QToolButton
    QToolTip
    QTransform
    QTreeView
    QTreeWidget
    QTreeWidgetItemIterator
    QUndoGroup
    QUndoStack
    QUndoView
    QValidator
    QVector2D
    QVector3D
    QVector4D
    QWhatsThis
    QWidget
    QMessageBox
    QWidgetAction
    QWindowsStyle
    QWizard
    QGuiPlatformPlugin
)

include_directories(
    ${CMAKE_BINARY_DIR}/include
    ${CMAKE_BINARY_DIR}/privateinclude
    ${CMAKE_BINARY_DIR}/include/QtCore
    ${CMAKE_BINARY_DIR}/include/QtXml
    ${CMAKE_BINARY_DIR}/include/QtGui
    ${FREETYPE_INCLUDE_DIRS}
    ${X11_INCLUDE_DIR}
    ${PNG_INCLUDE_DIRS}
)

set(GUI_HEADERS
    ${CMAKE_CURRENT_SOURCE_DIR}/animation/qabstractanimation.h
    ${CMAKE_CURRENT_SOURCE_DIR}/animation/qabstractanimation_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/animation/qvariantanimation.h
    ${CMAKE_CURRENT_SOURCE_DIR}/animation/qvariantanimation_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/animation/qpropertyanimation.h
    ${CMAKE_CURRENT_SOURCE_DIR}/animation/qpropertyanimation_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/animation/qanimationgroup.h
    ${CMAKE_CURRENT_SOURCE_DIR}/animation/qanimationgroup_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/animation/qsequentialanimationgroup.h
    ${CMAKE_CURRENT_SOURCE_DIR}/animation/qsequentialanimationgroup_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/animation/qparallelanimationgroup.h
    ${CMAKE_CURRENT_SOURCE_DIR}/animation/qparallelanimationgroup_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/animation/qpauseanimation.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qabstractprintdialog.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qabstractprintdialog_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qabstractpagesetupdialog.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qabstractpagesetupdialog_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qcolordialog.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qcolordialog_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qfscompleter_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qdialog.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qdialog_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qfiledialog.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qfiledialog_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qfontdialog.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qfontdialog_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qinputdialog.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qmessagebox.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qpagesetupdialog.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qpagesetupdialog_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qpagesetupdialog_unix_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qprintdialog.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qprintdialog_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qprogressdialog.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qsidebar_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qfilesystemmodel.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qfilesystemmodel_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qfileinfogatherer_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qwizard.h
    ${CMAKE_CURRENT_SOURCE_DIR}/dialogs/qprintpreviewdialog.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicsgridlayout.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicsitem.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicsitem_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicsitemanimation.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicslayout.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicslayout_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicslayoutitem.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicslayoutitem_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicslinearlayout.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicsproxywidget.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicsproxywidget_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicsscene.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicsscene_bsp_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicsscene_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicsscenebsptreeindex_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicssceneevent.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicssceneindex_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicsscenelinearindex_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicstransform.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicstransform_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicsview.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicsview_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicswidget.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicswidget_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgridlayoutengine_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraph_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qsimplex_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicsanchorlayout_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/graphicsview/qgraphicsanchorlayout.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qbitmap.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qicon.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qicon_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qiconloader_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qiconengine.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qiconengineplugin.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qimage.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qimage_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qimageiohandler.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qimagereader.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qimagewriter.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qmovie.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qpixmap.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qpixmapcache.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qpixmapdata_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qppmhandler_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qxpmhandler_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qpnghandler_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/image/qkathandler_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qabstractitemview.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qabstractitemview_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qheaderview.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qheaderview_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qidentityproxymodel.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qlistview.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qlistview_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qbsptree_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qtableview.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qtableview_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qtreeview.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qtreeview_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qabstractitemdelegate.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qitemdelegate.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qitemselectionmodel.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qitemselectionmodel_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qdirmodel.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qlistwidget.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qlistwidget_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qtablewidget.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qtablewidget_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qtreewidget.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qtreewidget_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qwidgetitemdata_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qproxymodel.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qproxymodel_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qabstractproxymodel.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qabstractproxymodel_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qsortfilterproxymodel.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qitemeditorfactory.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qitemeditorfactory_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qstandarditemmodel.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qstandarditemmodel_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qstringlistmodel.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qtreewidgetitemiterator.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qtreewidgetitemiterator_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qdatawidgetmapper.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qfileiconprovider.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qcolumnviewgrip_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qcolumnview.h 
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qcolumnview_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/itemviews/qstyleditemdelegate.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qaction.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qaction_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qactiongroup.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qapplication.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qapplication_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qboxlayout.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qclipboard.h

=== src/imports/CMakeLists.txt ===
# add_definitions()
set(EXTRA_IMPORTS_LIBS KtCore)

include_directories(
    ${CMAKE_BINARY_DIR}/include
    ${CMAKE_BINARY_DIR}/privateinclude
    ${CMAKE_BINARY_DIR}/include/QtCore
    ${CMAKE_BINARY_DIR}/include/QtGui
    ${CMAKE_BINARY_DIR}/include/QtDeclarative
    ${CMAKE_BINARY_DIR}/include/QtScript
)

# place the imports in a sub-directory the leading of which can be used as imports path,
# this makes testing without installation possible and is relied upon in the test script
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/imports/Qt/labs/folderlistmodel")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/imports/Qt/labs/folderlistmodel")
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/folderlistmodel/qmldir"
    "${CMAKE_BINARY_DIR}/imports/Qt/labs/folderlistmodel/qmldir"
)
add_subdirectory(folderlistmodel)


set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/imports/Qt/labs/particles")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/imports/Qt/labs/particles")
configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/particles/qmldir"
    "${CMAKE_BINARY_DIR}/imports/Qt/labs/particles/qmldir"
)
add_subdirectory(particles)

=== src/network/CMakeLists.txt ===
# add_definitions()
set(EXTRA_NETWORK_LIBS KtCore)

set(NETWORK_PUBLIC_HEADERS
    QAbstractSocket
    QHostAddress
    QHostInfo
    QLocalServer
    QLocalSocket
    QNetworkInterface
    QTcpServer
    QTcpSocket
    QUdpSocket
    QCryptographicHash
)

include_directories(
    ${CMAKE_BINARY_DIR}/include
    ${CMAKE_BINARY_DIR}/privateinclude
    ${CMAKE_BINARY_DIR}/include/QtCore
    ${CMAKE_BINARY_DIR}/include/QtNetwork
    ${CMAKE_SOURCE_DIR}/src/3rdparty/digest
)

set(NETWORK_HEADERS
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qcryptographichash.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qhostaddress.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qhostaddress_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qhostinfo.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qhostinfo_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qnetworkinterface.h
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qnetworkinterface_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/socket/qabstractsocketengine_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/socket/qabstractsocket.h
    ${CMAKE_CURRENT_SOURCE_DIR}/socket/qabstractsocket_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/socket/qtcpsocket.h
    ${CMAKE_CURRENT_SOURCE_DIR}/socket/qtcpsocket_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/socket/qudpsocket.h
    ${CMAKE_CURRENT_SOURCE_DIR}/socket/qtcpserver.h
    ${CMAKE_CURRENT_SOURCE_DIR}/socket/qlocalserver.h
    ${CMAKE_CURRENT_SOURCE_DIR}/socket/qlocalserver_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/socket/qlocalsocket.h
    ${CMAKE_CURRENT_SOURCE_DIR}/socket/qlocalsocket_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/socket/qnet_unix_p.h
    ${CMAKE_CURRENT_SOURCE_DIR}/qnetworkcommon_p.h
)

set(NETWORK_SOURCES
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qcryptographichash.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qhostaddress.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qhostinfo.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qnetworkinterface.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qhostinfo_unix.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/kernel/qnetworkinterface_unix.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/socket/qabstractsocketengine.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/socket/qabstractsocketengine_unix.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/socket/qabstractsocket.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/socket/qtcpsocket.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/socket/qudpsocket.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/socket/qtcpserver.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/socket/qlocalsocket.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/socket/qlocalserver.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/socket/qlocalsocket_unix.cpp
    ${CMAKE_CURRENT_SOURCE_DIR}/socket/qlocalserver_unix.cpp
    ${CMAKE_SOURCE_DIR}/src/3rdparty/digest/md5c.c
    ${CMAKE_SOURCE_DIR}/src/3rdparty/digest/sha1.c
    ${CMAKE_SOURCE_DIR}/src/3rdparty/digest/sha2.c
)

if(WITH_XXHASH AND XXHASH_FOUND)
    set(EXTRA_NETWORK_LIBS
        ${EXTRA_NETWORK_LIBS}
        ${XXHASH_LIBRARIES}
    )
    include_directories(${XXHASH_INCLUDES})
else()
    add_definitions(-DXXH_INLINE_ALL)
    include_directories(${CMAKE_SOURCE_DIR}/src/3rdparty/xxHash)
endif()

katie_generate_misc("${NETWORK_HEADERS}" QtNetwork)
katie_generate_public("${NETWORK_PUBLIC_HEADERS}" QtNetwork)
katie_generate_package(KtNetwork "KtCore")
katie_setup_target(KtNetwork ${NETWORK_SOURCES} ${NETWORK_HEADERS})

add_library(KtNetwork ${KATIE_TYPE} ${KtNetwork_SOURCES})
target_link_libraries(KtNetwork PRIVATE ${EXTRA_NETWORK_LIBS})
set_target_properties(KtNetwork PROPERTIES
    VERSION ${KATIE_MAJOR}.${KATIE_MINOR}
    SOVERSION ${KATIE_VERSION}
    EXPORT_NAME Network
)

install(
    TARGETS KtNetwork
    EXPORT KatieTargets
    DESTINATION ${KATIE_LIBRARIES_PATH}
    COMPONENT Runtime
)

install(
    DIRECTORY ${CMAKE_BINARY_DIR}/include/QtNetwork
    DESTINATION ${KATIE_HEADERS_PATH}
    COMPONENT Devel
)

katie_optimize_headers(${KATIE_HEADERS_PATH}/QtNetwork)

=== src/plugins/CMakeLists.txt ===
include_directories(
    ${CMAKE_BINARY_DIR}/include
    ${CMAKE_BINARY_DIR}/privateinclude
    ${CMAKE_BINARY_DIR}/include/QtCore
    ${CMAKE_BINARY_DIR}/include/QtGui
    ${CMAKE_BINARY_DIR}/include/QtDBus
    ${CMAKE_BINARY_DIR}/include/QtDeclarative
    ${CMAKE_BINARY_DIR}/include/QtUiTools
    ${CMAKE_BINARY_DIR}/include/QtNetwork
    ${CMAKE_BINARY_DIR}/include/QtScript
    ${CMAKE_BINARY_DIR}/include/QtSvg
)

# place the plugins in a sub-directory the leading of which can be used as plugin path,
# this makes testing without installation possible and is relied upon in the exec script
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/plugins/iconengines")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/plugins/iconengines")
add_subdirectory(iconengines/svgiconengine)


set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/plugins/imageformats")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/plugins/imageformats")
add_subdirectory(imageformats/svg)

set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/plugins/script")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/plugins/script")
if(WITH_DBUS AND DBUS_FOUND)
    add_subdirectory(script/qtdbus)
endif()


set(CMAKE_LIBRARY_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/plugins/designer")
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/plugins/designer")
add_subdirectory(designer/qdeclarativeview)

=== package/debian/changelog ===
katie (4.12.0) unstable; urgency=medium

  * Seventh package update

 -- Ivailo Monev <xakepa10@gmail.com>  Tue, 14 Dec 2021 09:36:46 +0200

katie (4.11.1) stable; urgency=medium

  * Sixed package update

 -- Ivailo Monev <xakepa10@gmail.com>  Tue, 23 Nov 2021 12:49:58 +0200

katie (4.11.0) stable; urgency=medium

  * Fifth package update

 -- Ivailo Monev <xakepa10@gmail.com>  Fri, 13 Aug 2021 07:32:58 +0200

katie (4.10.0) stable; urgency=medium

  * Fourth package update

 -- Ivailo Monev <xakepa10@gmail.com>  Mon, 8 Feb 2020 14:44:00 +0200

katie (4.9.2) stable; urgency=medium

  * Third package update

 -- Ivailo Monev <xakepa10@gmail.com>  Thu, 31 Dec 2020 14:44:00 +0200

katie (4.9.1) unstable; urgency=medium

  * Second package update

 -- Ivailo Monev <xakepa10@gmail.com>  Thu, 17 Dec 2020 16:26:26 +0200

katie (4.9.0) unstable; urgency=medium

  * First package update

 -- Ivailo Monev <xakepa10@gmail.com>  Mon, 7 Mar 2016 16:26:26 +0200

katie (4.8.7) unstable; urgency=medium

  * Initial package

 -- Ivailo Monev <xakepa10@gmail.com>  Sun, 10 Jan 2016 21:28:59 +0200

=== package/archlinux/PKGBUILD ===
# Maintainer: Ivailo Monev <xakepa10@gmail.com>

# https://wiki.archlinux.org/index.php/Arch_package_guidelines

pkgname=katie-git
pkgver=4.12.0.r7863.41bea107b
pkgrel=1
pkgdesc='C++ toolkit derived from the Qt 4.8 framework'
arch=('i486' 'i686' 'pentium4' 'x86_64' 'arm')
url='https://osdn.net/projects/kde/'
license=('LGPL' 'BSD')
depends=('libsm' 'libxcursor' 'libxinerama' 'libxrandr' 'fontconfig'
         'icu' 'jansson' 'libcups' 'xdg-utils' 'libdeflate')
makedepends=('cmake' 'git' 'unifdef')
optdepends=('gnu-free-fonts: last resort font')
source=("git+https://scm.osdn.net/gitroot/kde/Katie.git")
sha1sums=('SKIP')
conflicts=('katie')
# options=('debug')

pkgver() {
    cd Katie
    printf "4.12.0.r%s.%s" "$(git rev-list --count HEAD)" "$(git rev-parse --short HEAD)"
}

prepare() {
    mkdir -p build
}

build() {
    cd build
    cmake ../Katie \
        -Wno-dev \
        -DCMAKE_BUILD_TYPE=Release \
        -DCMAKE_INSTALL_PREFIX=/usr \
        -DKATIE_TOOLS_SUFFIX="-katie"
    make
}

package() {
    cd build
    make DESTDIR="${pkgdir}" install

    install -vDm644 ../Katie/LICENSE.BSD \
        "${pkgdir}/usr/share/licenses/katie-git/BSD.txt"
}

=== package/debian/control ===
Source: katie
Priority: optional
Maintainer: Ivailo Monev <xakepa10@gmail.com>
Homepage: https://osdn.net/projects/kde/
Vcs-Git: git://git.osdn.net/gitroot/kde/Katie.git
Vcs-browser: https://osdn.net/projects/kde/scm/git/Katie/tree
Standards-Version: 4.12.0
Build-Depends: debhelper (>= 9~), libdeflate-dev, libgettextpo-dev,
 libc6-dev, libjansson-dev, libpng-dev, libcups2-dev, libfreetype6-dev,
 libfontconfig1-dev, libdbus-1-dev, libicu-dev, cmake, git,
 xserver-xorg-dev, libxinerama-dev, libxrandr-dev, libxrender-dev,
 libxcursor-dev, libsm-dev, unifdef | dpkg

Package: katie-runtime
Architecture: amd64 arm64 armel armhf i386 mips mips64el mipsel ppc64el s390x hurd-i386
Section: x11
Depends: ${shlibs:Depends}, ${misc:Depends}, xdg-utils
Recommends: xserver-xorg-core, fonts-freefont-ttf
Description: C++ toolkit derived from the Qt 4.8 framework
 Katie is continuation of the Qt4 C++ toolkit with the goal to keep it alive,
 clean it up, fix some bugs and backport some features from Qt5. It is based
 on the latest Git revision of Qt v4.8.
 .
 This package includes includes libraries, imports, plugins and translations

Package: katie-tools
Architecture: amd64 arm64 armel armhf i386 mips mips64el mipsel ppc64el s390x hurd-i386
Section: x11
Depends: ${shlibs:Depends}, ${misc:Depends}, katie-runtime
Description: C++ toolkit derived from the Qt 4.8 framework
 Katie is continuation of the Qt4 C++ toolkit with the goal to keep it alive,
 clean it up, fix some bugs and backport some features from Qt5. It is based
 on the latest Git revision of Qt v4.8.
 .
 This package includes designer, moc, qdbus, qdbuscpp2xml, qdbusviewer,
 qdbusxml2cpp, qscript, qtconfig, rcc, and uic

Package: katie-dev
Architecture: amd64 arm64 armel armhf i386 mips mips64el mipsel ppc64el s390x hurd-i386
Section: devel
Depends: ${misc:Depends}, katie-runtime, katie-tools
Description: C++ toolkit derived from the Qt 4.8 framework
 Katie is continuation of the Qt4 C++ toolkit with the goal to keep it alive,
 clean it up, fix some bugs and backport some features from Qt5. It is based
 on the latest Git revision of Qt v4.8.
 .
 This package includes headers, pkg-config and CMake files

Package: katie-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}, man-db
Description: C++ toolkit derived from the Qt 4.8 framework
 Katie is continuation of the Qt4 C++ toolkit with the goal to keep it alive,
 clean it up, fix some bugs and backport some features from Qt5. It is based
 on the latest Git revision of Qt v4.8.
 .
 This package includes manual pages for the tools

=== package/debian/rules ===
#!/usr/bin/make -f

KATIE_CROSS_EMULATOR=""
ifneq ($(DEB_HOST_ARCH_CPU),$(DEB_BUILD_ARCH_CPU))
	KATIE_CROSS_EMULATOR="qemu-$(DEB_HOST_GNU_CPU)-static"
endif

KATIE_BUILD_DIR="$(shell pwd)/obj-$(DEB_HOST_GNU_TYPE)"

%:
	dh $@ --parallel

override_dh_shlibdeps:
	dh_shlibdeps -l$(KATIE_BUILD_DIR)/lib

override_dh_auto_configure:
	dh_auto_configure -- -Wno-dev \
		-DKATIE_TOOLS_SUFFIX="-katie" \
		-DCMAKE_CROSSCOMPILING_EMULATOR=$(KATIE_CROSS_EMULATOR)

override_dh_auto_install:
	$(MAKE) -C $(KATIE_BUILD_DIR) install-runtime DESTDIR=../debian/katie-runtime
	rm -vrf debian/katie-runtime/etc/
	$(MAKE) -C $(KATIE_BUILD_DIR) install-tools DESTDIR=../debian/katie-tools
	$(MAKE) -C $(KATIE_BUILD_DIR) install-devel DESTDIR=../debian/katie-dev
	$(MAKE) -C $(KATIE_BUILD_DIR) install-doc DESTDIR=../debian/katie-doc
	dpkg-gensymbols -q -Odebian/katie-runtime.symbols -Pdebian/katie-runtime -pkatie-runtime
